#ifndef _NETWORK_H_

#define _NETWORK_H_

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <unistd.h>
#include "monkeyircd.h"		/* We need the types from in here */

/* Return values and constants */
#define NET_MAXLISTEN 		100

/* Max buffer size */
#define BUF_SIZE 512-HOST_LENGTH-NICK_LENGTH-USER_LENGTH-5
/* Ping related stuff */
#define PING_SECS		90

/* Lots of these can be cut down */
int setup_tcp (struct addrinfo *);
/* These are the mainstay */
int send_client_client (ClientInfo, ClientInfo, char *);
int send_origin_server (ServerInfo, char *, char *);
int send_origin_client (ClientInfo, char *, char *);
int send_numeric (ClientInfo, ServerInfo, int, char *);
int send_to_channel (ClientInfo, ChannelInfo, char *);
int send_to_channel_selective (ClientInfo, ChannelInfo, ServerInfo, char *);
int send_to_local_channel (ClientInfo, ChannelInfo, char *);
int send_to_local_channel_ops (ClientInfo, ChannelInfo, char *);
/* Specialist Ones */
int send_temp (struct tempinfo *, char *);
int send_ping (struct fd_wrap *);
int send_motd (ClientInfo);
int send_namelists (ChannelInfo, ClientInfo);
int send_lusers (ClientInfo, char *);
/* Quit/Socket Close Stuff */
int force_quit (int, char *);

#endif
