#ifndef _SERVER_H_

#define _SERVER_H_

#include "network.h"
#include "config_file.h"
#include "monkeyircd.h"
#include "client.h"

#define SERV_HASH_SIZE		50

int server_hash_init (char *, char *, char *);
int server_hash_add (ServerInfo);
int server_hash_rem (char *);
ServerInfo server_locate (char *);
/* Passes a message to all directly connected servers */
int servers_announce (char *, char *);
int servers_relay (ServerInfo, char *, char *);
/* Used to pass known servers to a newly-connected server */
int servers_introduce (ServerInfo);
/* Sends out a server reg message to all local servers */
/* used in ircd.c and cmd_server.c */
int server_reg_announce (ServerInfo);
int server_squit_announce (ServerInfo, char *);
int server_squit_generate (ServerInfo, char *, char *);
/* Returns our struct pointer */
ServerInfo get_my_server ();
/* Calculate the global client/server counts */
int servers_global_counts (char *, long int *, long int *);
/* Send Links Reply */
int server_links (ClientInfo, char *);

#endif
